MetaHudO_NUMTABS = 5;

function MetaHudO_Header_OnLoad(x,y)
    this.setting_name = string.gsub( this:GetName() , "MetaHud_", "");
    local text = getglobal( this:GetName().."Text");
    text:SetText( " "..(MetaHudO_locale[this.setting_name] or "["..(this.setting_name).."]") );
    text:ClearAllPoints();
    text:SetHeight(20);
    text:SetPoint("TOPLEFT", "MetaHudOptionsFrame" , "TOPLEFT", x, y);
end

function MetaHudO_OnLoad()
    table.insert(UISpecialFrames, "MetaHudOptionsFrame");
    PanelTemplates_SetNumTabs(this, MetaHudO_NUMTABS);
    PanelTemplates_SetTab(this, 1);    
end

function MetaHudO_DropDown_Initialize()
	local info = {};
	local index;
	
    index = string.gsub( this:GetName() , "MetaHud_Edit_", "");
	index = string.gsub( index , "_Selection", "");
	index = string.gsub( index , "Button", "");
	
	local table = MetaHudO_SELECTION[index]["table"];
    for key, text in table do
        info = {};
        info.text = text;
        info.func = MetaHudO_DropDown_OnClick;
        info.arg1 = index;
        UIDropDownMenu_AddButton(info);
    end
end

function MetaHudO_DropDown_OnClick(list)
    local sel = getglobal("MetaHud_Edit_"..list.."_Selection");
    local box = getglobal("MetaHud_Edit_"..list.."ScrollFrameText");
    local text = MetaHudO_SELECTION[list]["values"][ this:GetID() ];
    box:SetText(text);
    UIDropDownMenu_SetSelectedID( sel , this:GetID() );
    MetaHud:SetConfig( list, text );
    MetaHudO_updateTexts(list);
    MetaHud:init();
end

function MetaHudO_updateTexts(name)
    MetaHud:initTextfield(getglobal(name),name);
    MetaHud:triggerTextEvent(name);
end
        
function MetaHudO_FrameSlider_OnLoad(low, high, step)
    this.setting_name = string.gsub( this:GetName() , "MetaHud_Slider_", "");
    this.st = step;
    if this.nullbase == 1 then
	   getglobal(this:GetName().."Low"):SetText( (low - low) );
	   getglobal(this:GetName().."High"):SetText( (high - low));     
	   this.low = low;  
    else
	   getglobal(this:GetName().."Low"):SetText(low);
	   getglobal(this:GetName().."High"):SetText(high);        
    end
	this:SetMinMaxValues(low, high);
	this:SetValueStep(this.st);
end

function MetaHudO_FrameSlider_OnShow( key,text)
    getglobal(this:GetName()):SetValue(MetaHudOptions[key]);
    if this.nullbase == 1 then
        getglobal(this:GetName().."Text"):SetText(text.." "..(MetaHudOptions[key] - this.low ).." ");
    else
        getglobal(this:GetName().."Text"):SetText(text.." "..MetaHudOptions[key].." ");
    end
end

function MetaHudO_FrameSlider_OnValueChanged(key,text)

     local m;
     local value;
     
     if this.st == nil then
        m = 0;
     end
     
     if this.st == 1 then
        m = 0;
     end
     
     if this.st == 0.1 then
        m = 10;
     end
     
     if this.st == 0.01 then
        m = 100;
     end
     
     if this.st == 0.001 then
        m = 1000;
     end
                    
     if m > 0 then
         value =  math.floor( ( this:GetValue() + 0.00001) * m ) / m; 
     else
         value =  math.floor( this:GetValue() ); 
     end
     
	 MetaHud:SetConfig( key, value );
    if this.nullbase == 1 then
        getglobal(this:GetName().."Text"):SetText(text.." "..(MetaHudOptions[key] - this.low ).." ");
    else
        getglobal(this:GetName().."Text"):SetText(text.." "..MetaHudOptions[key].." ");
    end
	 MetaHud:init();
	 
    if this.triggertext then
        MetaHud:triggerAllTextEvents();
    end
end

function MetaHudO_ColorPicker_ColorChanged()
	local r, g, b = ColorPickerFrame:GetColorRGB();

    MetaHudOptions["colors"][ColorPickerFrame.objname][ColorPickerFrame.objindex] = MetaHud_DecToHex(r,g,b);
    --getglobal(ColorPickerFrame.tohue):SetTexture(r,g,b);
    MetaHudO_changeG(ColorPickerFrame.objname);
    MetaHud:init();
end

function MetaHudO_ColorPicker_OnClick(boxnumber)

    local name = string.gsub( this:GetName() , "MetaHud_Colorbox_", "");
    name = string.gsub( name , boxnumber, "");
    local Red, Green, Blue = unpack(MetaHud_hextodec(MetaHudOptions["colors"][name][boxnumber]));
    

    ColorPickerFrame.previousValues = {Red, Green, Blue}
    ColorPickerFrame.cancelFunc     = MetaHudO_ColorPicker_Cancelled
    ColorPickerFrame.func           = MetaHudO_ColorPicker_ColorChanged
    ColorPickerFrame.objname        = name
    ColorPickerFrame.objindex       = boxnumber
    ColorPickerFrame.tohue          = "MetaHud_Colorbox_"..name..boxnumber.."Texture";
    ColorPickerFrame.hasOpacity     = false
    ColorPickerFrame:SetColorRGB(Red, Green, Blue)
    ColorPickerFrame:ClearAllPoints()
    local x = MetaHudOptionsFrame:GetCenter()
    if (x < UIParent:GetWidth() / 2) then
        ColorPickerFrame:SetPoint("LEFT", "MetaHudOptionsFrame", "RIGHT", 0, 0)
    else
        ColorPickerFrame:SetPoint("RIGHT", "MetaHudOptionsFrame", "LEFT", 0, 0)
    end

    ColorPickerFrame:Show()
end

function MetaHudO_ColorPicker_Cancelled(color)

    local r,g,b = unpack(color);
    MetaHudOptions["colors"][ColorPickerFrame.objname][ColorPickerFrame.objindex] = MetaHud_DecToHex(r,g,b);
    --getglobal(ColorPickerFrame.tohue):SetTexture(r,g,b);
    MetaHudO_changeG(ColorPickerFrame.objname);
    MetaHud:init();
 
end

function MetaHudO_changeG(name)
	local Hcolor1 = MetaHudOptions["colors"][name][1];
	local Hcolor2 = MetaHudOptions["colors"][name][2];
	local Hcolor3 = MetaHudOptions["colors"][name][3];
	local c1r,c1g,c1b = unpack(MetaHud_hextodec(Hcolor1));
	local c2r,c2g,c2b = unpack(MetaHud_hextodec(Hcolor2));
	local c3r,c3g,c3b = unpack(MetaHud_hextodec(Hcolor3));
	local basename = "MetaHud_Colorbox_"..name;
	getglobal(basename.."1Texture"):SetTexture(c1r,c1g,c1b);
	getglobal(basename.."2Texture"):SetTexture(c2r,c2g,c2b);
	getglobal(basename.."3Texture"):SetTexture(c3r,c3g,c3b);
	getglobal(basename.."G1Texture"):SetGradient("HORIZONTAL",c1r,c1g,c1b, c2r,c2g,c2b);
	getglobal(basename.."G2Texture"):SetGradient("HORIZONTAL",c2r,c2g,c2b, c3r,c3g,c3b);
end

function MetaHud_RadioButton_OnClick(index)
	MetaHud_RADIO_layout1:SetChecked(nil);
	MetaHud_RADIO_layout2:SetChecked(nil);
	if index == 1 then
		MetaHud_RADIO_layout1:SetChecked(1);
		MetaHud:transformFrames("MetaHud_Standard_Layout");
	else
		MetaHud_RADIO_layout2:SetChecked(1);
		MetaHud:transformFrames("MetaHud_PlayerLeft_Layout");
	end
end

function MetaHud_SwitchButton_Select(index)
	for i=1, 5, 1 do
		if(index == "font") then
			if(i == MetaHudOptions.fontfile) then
				getglobal("MetaHud_fontfile"..i):SetChecked(1);
			else
				getglobal("MetaHud_fontfile"..i):SetChecked(nil);
			end
		elseif(index == "sound") then
			if(i == MetaHudOptions.soundfile) then
				getglobal("MetaHud_soundfile"..i):SetChecked(1);
			else
				getglobal("MetaHud_soundfile"..i):SetChecked(nil);
			end
		elseif(index == "texture") then
			if(i == MetaHudOptions.texturefile) then
				getglobal("MetaHud_texturefile"..i):SetChecked(1);
			else
				getglobal("MetaHud_texturefile"..i):SetChecked(nil);
			end
			MetaHud:transformFrames(MetaHud.C_curLayout);
		end
	end
	MetaHud:init();
end

function MetaHud_SwitchButton_OnClick(id)
	local index = string.gsub( this:GetName() , "MetaHud_", "");
	index = string.gsub( index , "file"..id, "");
	if(index == "font") then
		MetaHudOptions.fontfile = id;
	elseif(index == "sound") then
		MetaHudOptions.soundfile = id;
	elseif(index == "texture") then
		MetaHudOptions.texturefile = id;
	end
	MetaHud_SwitchButton_Select(index);
end
